# !/usr/bin/python
# -*- coding: utf-8 -*-
# @Author:: Arthur Wu
# @Date:: 2024/11/12-11:28
# @Description::
''' 客户端API接口列表 '''


api_env = {
    "test_env": "https://api.test.yimaogo.com/cart",
    "gray_env": "https://api.yimaogo.com/cart",
}

ApplicatonApi_zh = {
    # 01-session
    "session数据上报": "/v1/session/report/case", # POST
    "session开始": "/v1/session/start", # POST
    "session数据批量上报": "/v2/session/report/case", # POST
    "session结束": "/v1/session/end", # PUT
    "更新session的业务字段": "/v1/session/update", # POST

    # 02-登录
    "小程序码": "/v1/login/getMiniProgramUrl", # POST
    "登录V1": "/v1/login", # POST 仅杭联走V1
    "登录V2": "/v2/login", # POST 其他都走V2
    "支付宝刷脸初始化": "/v1/login/initialize", # POST
    "会员扫码联华": "/v1/login/unlockCart", # POST
    "会员选择": "/v2/login/{customerId}", # POST
    "获取购物车登录类型": "/v2/login/type", # GET

    # 03-私人物品
    "私人物品新增保存": "/v1/personal/things/save", # POST

    # 04-车辆
    "获取购物车信息": "/v1/cart/info", # GET
    "获取商超购物车POS配置": "/v1/cart/pos/config", # GET
    "获取门店列表": "/v1/cart/storeList", # GET
    "购物车注册": "/v1/cart/register", # POST

    # 05-闸机
    "获取闸机信息": "/v1/gate/info", # GET
    "吐袋机吐袋数量上报": "/v1/gate/bag/num", # POST
    "检查是否可以开门": "/v1/gate/canOpen", # GET
    "查询订单详情": "/v1/gate/queryOrderInfoByMac", # GET
    "闸机开门": "/v1/gate/openDoor", # POST
    "获取订单列表": "/v1/gate/order", # POST
    "核验订单": "/v1/gate/checkOrder", # GET
    "小票打印": "/v1/gate/order/printReceipt", # GET
    "手动小票打印": "/v1/gate/order/manualPrintReceipt", # GET
    "结算单打印": "/v1/gate/order/getSettlementInfo", # GET
    "绑定订单接口": "/v1/gate/order/bind", # POST

    # 06-广告
    "获取广告列表": "/v1/ads/list", # GET
    "查询广告详情": "/v1/ads/{adsId}", # GET

    # 07-优惠券
    "获取优惠券的规则": "/v1/coupon/list/settings", # POST
    "获取车上优惠券": "/v1/coupon/list", # POST
    "领取优惠券": "/v1/coupon/receive", # POST
    "查询用户有的优惠券": "/v1/coupon/list/user", # GET
    "V2百联用券接口": "/v2/coupon/bl/use", # POST
    "V2百联取消用券接口": "/v2/coupon/bl/cancel/use", # POST
    "V2百联优惠券支付接口": "/v2/coupon/bl/pay", # POST
    "永辉优惠劵兑换": "/v1/coupon/getTouristCoupon", # GET

    # 08-商品
    "获取商品信息(客户端输入inputCode)": "/v2/shopping/{inputCode}", # GET
    "获取商品信息": "/v1/shopping/{barcode}", # GET
    "无条码商品列表": "/v1/shpping/no/barcode/list", # GET
    "获取采集商品信息": "/v1/shopping/collect/6921168509256", # GET

    # 09-购物
    "获取购物车商品信息": "/v1/shopping/cart/goods/info", # POST
    "加购/退购接口V2": "/v2/shopping/add/retire/purchase", # POST
    "获取无条形码商品列表": "/v1/shopping/no/barcode/list", # GET
    "清空购物车": "/v1/shopping/clear/cart", # POST
    "加购/退购接口": "/v1/shopping/add/retire/purchase", # POST
    "订单结算": "/v1/shopping/order/settle", # POST
    "订单支付": "/v1/shopping/order/pay", # POST
    "查询订单支付": "/v1/shopping/query/order/pay", # GET
    "订单取消": "/v1/shopping/order/cancel", # POST
    "聚合支付通知": "/v1/shopping/pay/notify", # POST
    "获取购物车商品信息V2": "/v2/shopping/cart/goods/info", # POST
    "订单结算V2": "/v2/shopping/order/settle", # POST
    "购物车商品识别": "/v2/shopping/predict", # POST

    # 10-鉴权
    "MQTT": "/v1/auth/mqtt", # POST
    "核验码鉴权": "/v1/auth/verification", # POST

    # 11-核验
    "核验商品上报": "/v1/check/goods", # POST
    "核验私人物品上报": "/v1/check/personal", # POST
    "通过核验商品": "/v1/check/goods/update", # POST
    "采集商品重量": "/v1/check/collectGoodsWeight", # POST

    # 12-文件上传
    "文件上传": "/v1/upload/s3", # POST

    # 13-日志上报
    "日志上报": "/v1/log", # POST
    "闸机上报": "/v1/log/gate", # POST

    # 14-传感器信息采集
    "记录上传": "/v1/sensor/record", # POST

    # 15-地图导航
    "获取门店区域列表": "/v1/navigation/area", # GET

    # 16-抽奖活动
    "抽奖活动入口": "/v1/lottery/entrance", # POST
    "抽奖页面初始化": "/v1/lottery/init", # POST
    "抽奖": "/v1/lottery/draw", # POST
    "查询奖品列表": "/v1/lottery/prize/list", # POST

    # 17-派样活动
    "老系统同步派样活动": "/v1/sample/sync/activity", # POST
    "老系统同步派样记录": "/v1/sample/sync", # POST
    "绑定派样": "/v1/sample/bind", # POST
    "核销派样": "/v1/sample/write/off", # POST
    "分页查询派样记录": "/v1/sample/list", # POST

    # 18-微信小程序
    "获取赠品绑定小程序码": "/mp/getQrCode", # POST

    # 19-埋点上报
    "埋点上报": "/v1/event/tracking/report", # POST

    # 20-配套软件
    "获取门店配套软件": "/v1/supporting/software/list", # POST

    # 21-MQTT查询
    "会员登录查询": "/v1/mqtt/login", # GET
    "商品核验状态查询": "/v1/mqtt/check/goods", # GET
    "私人物品核验状态查询": "/v1/mqtt/check/personal", # GET
    "出闸状态查询": "/v1/mqtt/gate/out", # GET
    "绑定账号结果查询": "/v1/mqtt/member/bind", # GET

    # 22-本地特征库
    "本地特征库upgrade": "/v1/usearch/upgrade", # POST

    # 23-登录接口
    "会员扫码回调": "/v2/login/unlockCart", # POST
}




