# !/usr/bin/python
# -*- coding: utf-8 -*-
# @Author:: Arthur Wu
# @Date:: 2024/10/14-11:50
# @Description:: API接口信息
api_env = {
    "test_env": "https://api.test.yimaogo.com/",
    "gray_env": "https://api.yimaogo.com/",
}
ManagementPlatformApi_zh = {
    "编辑超市系统参数":  "admin/system/settings", # 超市管理 (MarketID：可以通过查询超市接口获取)

    "编辑门店系统参数": "admin/system/settings", # 门店管理 (StoreID：可以通过查询门店接口获取)
    "删除门店系统参数": "admin/system/settings/{StoreID}",
    "新建促销商品白名单": "admin/goods/promotion",
    "修改与删除促销商品白名单": "admin/goods/promotion/{GoodsWhiteListID}", # GoodsWhiteListID：可以通过新建时过程存储，调用删除接口时再读取
    "新建重量放通白名单": "admin/goods/weight/promotion",
    "修改与删除重量放通白名单": "admin/goods/weight/promotion/{WeightWhiteListID}", # WeightWhiteListID：可以通过新建时过程存储，其他接口使用时再读取

    "新建派样活动": "admin/sample/activity", # 派样活动
    "查询派样活动": "admin/sample/activity/list",
    "修改与删除派样活动": "admin/sample/activity/{SampleActivityID}", # ：可以通过新建时过程存储，其他接口使用时再读取
    "暂停派样活动": "admin/sample/activity/change/status/{SampleActivityID}?status=3",
    "重新发布派样活动": "admin/sample/activity/change/status/{SampleActivityID}?status=2",
    "立即结束派样活动": "admin/sample/activity/change/status/{SampleActivityID}?status=4",
    "复制派样活动": "admin/sample/activity",
    "新建抽奖活动": "admin/lotteryAct", # 抽奖活动
    "查询抽奖活动": "admin/lotteryAct/list",
    "修改与删除抽奖活动": "admin/lotteryAct/{LotteryActID}",
    "编辑抽奖活动状态": "admin/lotteryAct/modifyStatus/{LotteryActID}", # ：可以通过新建时过程存储，其他接口使用时再读取
    "复制抽奖活动": "admin/lotteryAct/copy/{LotteryActID}",

    "新建优惠券活动": "admin/coupon/setting", # 优惠券活动
    "查询优惠券活动": "admin/coupon/setting/list",
    "暂停优惠券活动": "admin/coupon/setting/status/{CouponID}?status=6", # ：可以通过新建时过程存储，其他接口使用时再读取
    "重新开启优惠券活动": "admin/coupon/setting/status/{CouponID}?status=4",
    "结束投放优惠券活动": "admin/coupon/setting/status/{CouponID}?status=7",
    "修改与删除优惠券活动": "admin/coupon/setting/{CouponID}",
    "复制优惠券活动": "admin/coupon/setting",

    "新建广告": "admin/ads", # 广告活动
    "复制广告": "admin/ads", # 广告活动
    "查询广告": "admin/ads/list",
    "修改与删除广告": "admin/ads/{ADsID}", # ：可以通过新建时过程存储，其他接口使用时再读取
    "暂停广告投放": "admin/ads/status/{ADsID}?status=6",
    "重新投放广告": "admin/ads/status/{ADsID}?status=4",
    "结束投放广告": "admin/ads/status/{ADsID}?status=7",

    "新建版本信息": "admin/apk", # 版本管理
    "查询版本信息": "admin/apk/list",
    "修改与删除版本信息": "admin/apk/{VersionID}", # ：可以通过新建时过程存储，其他接口使用时再读取

    "新建升级任务": "admin/upgrade/settings", # 升级任务
    "查询升级任务": "admin/upgrade/settings/list",
    "修改与删除升级任务": "admin/upgrade/settings/{UpgradeID}", # ：可以通过新建时过程存储，其他接口使用时再读取
    "启禁升级任务": "admin/upgrade/settings/active/{UpgradeID}",
}


