# !/usr/bin/python
# -*- coding: utf-8 -*-
# @Author:: Arthur Wu
# @Date:: 2024/11/18-9:38
# @Description::
import unittest,allure,time
from configs.globalObj import LOGGER
from YiMao.businessFunc.ClientApiLib import YMClientApi
from YiMao.data.WuShangSceneTestData import *


DescName = "002-非会员加购购物袋并试算"
@allure.story(f'[场景测试] {DescName}验证')
class Test_C002_NonVipAddShoppingBagAndSettlePayment(unittest.TestCase):
    f'''@Date:: 2024/11/15
    @Author:: Arthur Wu
    @Desc::
    [购物车客户端] {DescName}
    1、武商测试环境，购物袋inputcode为：
       6971648922990、6971648922983
    '''
    def setUp(self) -> None:
        self.timestamp = int(time.time())
        self.ymc = YMClientApi()
        self.goodsbag_mid = GoodsBagInputcode_mid
        self.goodsbag_max = GoodsBagInputcode_max

    def test_C00201_AddMidShoppingbagsForPurchase(self):
        allure.dynamic.description(f"描述：加购中号购物袋")
        allure.step("步骤1：session开始")
        self.ymc.session_start()
        allure.step("步骤2：匿名登录")
        Payload01 = {"action": 0, "isAnon": True}
        LoginData = self.ymc.login_app_v2(Payload01)
        allure.step("步骤3：获取商品信息")
        GoodsInfoData = self.ymc.get_goods_info(self.goodsbag_mid)
        if GoodsInfoData['msg'] != '加购商品不存在':
            allure.step("步骤4：添加购物袋")
            self.ymc.add_cart_goods(GoodsInfoData, 2, LoginData)
            allure.step("步骤5：获取购物车商品信息")
            self.ymc.get_cart_goods_info([GoodsInfoData])
            allure.step("步骤6：请求订单结算")
            self.ymc.request_order_settlement(LoginData)
        else:
            LOGGER.info(f"---购物袋 {self.goodsbag_mid} 不存在")

    def test_C00202_AddMaxShoppingbagsForPurchase(self):
        allure.dynamic.description("描述：加购大号购物袋")
        allure.step("步骤1：session开始")
        self.ymc.session_start()
        allure.step("步骤2：匿名登录")
        Payload01 = {"action": 0, "isAnon": True}
        LoginData = self.ymc.login_app_v2(Payload01)
        allure.step("步骤3：获取商品信息")
        GoodsInfoData = self.ymc.get_goods_info(self.goodsbag_max)
        if GoodsInfoData['msg'] != '加购商品不存在':
            allure.step("步骤4：添加购物袋")
            self.ymc.add_cart_goods(GoodsInfoData, 2, LoginData)
            allure.step("步骤5：获取购物车商品信息")
            self.ymc.get_cart_goods_info([GoodsInfoData])
            allure.step("步骤6：请求订单结算")
            self.ymc.request_order_settlement(LoginData)
        else:
            LOGGER.info(f"---购物袋 {self.goodsbag_max} 不存在")


if __name__ == '__main__':
    unittest.main(verbosity=2)