# !/usr/bin/python
# -*- coding: utf-8 -*-
# @Author:: Arthur Wu
# @Description:: 游客登录，加购会员商品并结算
# @Date:: 2021-05-10 16:30:23
import unittest,allure,time
from configs.globalObj import LOGGER
from YiMao.businessFunc.ClientApiLib import YMClientApi
from YiMao.data.WuShangSceneTestData import *


DescName = "004-非会员加购会员商品并结算"
@allure.story(f'[场景测试] {DescName}验证')
class Test_C004(unittest.TestCase):
    f'''@Date:: 2024/11/15
    @Author:: Arthur Wu
    @Desc::
    [购物车客户端] {DescName}
    1、武商测试环境，会员有优惠商品inputcode为：
    ！！！！会员有优惠商品暂未提供
    '''
    def setUp(self) -> None:
        self.timestamp = int(time.time())
        self.ymc = YMClientApi()
        # 会员有优惠商品暂未提供
        self.vip_goods_inputcode = VipGoodsInputcode # 统一番茄牛肉面

    def test_C004_NonVipAddMemberPproductsForPurchase(self):
        allure.dynamic.description(f"描述：{DescName}")
        allure.step("步骤1：session开始")
        self.ymc.session_start()
        allure.step("步骤2：匿名登录")
        Payload01 = {"action": 0, "isAnon": True}
        LoginData = self.ymc.login_app_v2(Payload01)
        allure.step("步骤3：获取商品信息")
        GoodsInfoData = self.ymc.get_goods_info(self.vip_goods_inputcode)
        if GoodsInfoData['msg'] != '加购商品不存在':
            allure.step("步骤4：添加会员有优惠商品")
            self.ymc.add_cart_goods(GoodsInfoData, 1, LoginData)
            allure.step("步骤5：获取购物车商品信息")
            self.ymc.get_cart_goods_info([GoodsInfoData])
            allure.step("步骤6：请求订单结算")
            self.ymc.request_order_settlement(LoginData)
        else:
            LOGGER.info(f"---商品 {self.vip_goods_inputcode} 不存在")


if __name__ == '__main__':
    unittest.main(verbosity=2)