# !/usr/bin/python
# -*- coding: utf-8 -*-
# @Author:: Arthur Wu
# @Description:: 游客登录，加购2个打折商品，退购一个，并结算
# @Date:: 2024/11/20
import unittest,allure,time
from configs.globalObj import LOGGER
from YiMao.businessFunc.ClientApiLib import YMClientApi
from YiMao.data.WuShangSceneTestData import *

DescName = "013-非会员，加购2个打折商品，退购一个，并结算"
@allure.story(f'[场景测试] {DescName}验证')
class Test_C013(unittest.TestCase):
    f'''@Date:: 2024/11/20
    @Author:: Arthur Wu
    @Desc::
    [购物车客户端] {DescName}
    1、武商测试环境，2个打折商品 inputcode 分别为：
    '''
    def setUp(self) -> None:
        self.timestamp = int(time.time())
        self.ymc = YMClientApi()
        self.sale_goods_inputCode = SaleGoodsInputCode  # 乐事薯片

    def test_C013_NonVipReturnOfDiscountedProducts(self):
        allure.dynamic.description(f"描述：{DescName}")
        allure.step("步骤1：session开始")
        self.ymc.session_start()
        allure.step("步骤2：匿名登录")
        Payload01 = {"action": 0, "isAnon": True}
        LoginData = self.ymc.login_app_v2(Payload01)
        '''step1：加购商品x，分别加购x件'''
        allure.step("步骤3：获取商品1信息")
        GetGoodsInfoResp_01 = self.ymc.get_goods_info(InputCode=self.sale_goods_inputCode)
        if GetGoodsInfoResp_01['msg'] != '加购商品不存在':
            allure.step("步骤4：添加商品1")
            AddGoodsResp = self.ymc.add_cart_goods(GetGoodsInfoResp_01, 2, LoginData)

            ''' step2：随机退购一个商品，并结算 '''
            allure.step("\n步骤5：退购一件商品")
            GetGoodsInfoList = [GetGoodsInfoResp_01]
            self.ymc.delete_cart_goods(GetGoodsInfoList, LoginData, AddGoodsResp)

            allure.step("步骤6：获取购物车商品信息")
            self.ymc.get_cart_goods_info([GetGoodsInfoResp_01])
            allure.step("步骤7：请求订单结算")
            self.ymc.request_order_settlement(LoginData)
        else:
            LOGGER.info(f"---商品 {self.sale_goods_inputCode} 不存在")


if __name__ == '__main__':
    unittest.main(verbosity=2)

