# !/usr/bin/python
# -*- coding: utf-8 -*-
# @Author:: Arthur Wu
# @Description:: 游客登录，加购2个重量放通商品，退购一个，并结算
# @Date:: 2024/11/20
import unittest,allure,time
from configs.globalObj import LOGGER
from YiMao.businessFunc.ClientApiLib import YMClientApi
from YiMao.businessFunc.ServiceApiLib import YMServiceApi
from YiMao.data.WuShangSceneTestData import *


DescName = "015-非会员加购2个重量放通商品，退购一个"
@allure.story(f'[场景测试] {DescName}验证')
class Test_C015(unittest.TestCase):
    f'''@Date:: 2024/11/20
    @Author:: Arthur Wu
    @Desc::
    [购物车客户端] {DescName}
    1、武商测试环境，重量放通白名单商品 inputcode 分别为：
    '''
    def setUp(self) -> None:
        self.timestamp = int(time.time())
        self.ymc = YMClientApi()
        self.yms = YMServiceApi()
        # 重量放通白名单商品暂未提供
        self.weight_to_whitelist_goods = WeightToWhitelistGoods
        self.market_and_store_info = {
            "MarketId": MarketAndStoreDetails["putMarketId"],
            "StoreId": MarketAndStoreDetails["putStoreId"][0]
        }

    def test_C015_NonVipReturnWeightOfTheProducte(self):
        allure.dynamic.description(f"描述：{DescName}")
        allure.step("[前置条件]：先调用管理平台接口，将指定商品添加到重量放通白名单中")
        pre_respomse = self.yms.add_weight_to_whitelist(
            self.weight_to_whitelist_goods, self.market_and_store_info
        )
        if pre_respomse['data'] is not None:
            LOGGER.info(f"---商品 {self.weight_to_whitelist_goods['GoodsInputcode']} "
                        f"已添加到重量放通白名单中")
            ''' 2-再调用客户端接口，执行加购操作 '''
            allure.step("[业务步骤]：再调用客户端接口，执行加购操作")
            allure.step("步骤1：session开始")
            self.ymc.session_start()
            allure.step("步骤2：匿名登录")
            Payload01 = {"action": 0, "isAnon": True}
            LoginData = self.ymc.login_app_v2(Payload01)

            allure.step("步骤3：获取重量放通白名单商品信息")
            GoodsInfoData1 = self.ymc.get_goods_info(self.weight_to_whitelist_goods["GoodsInputcode"])
            if GoodsInfoData1['msg'] != '加购商品不存在':
                allure.step("步骤4：加购白名单商品")
                AddGoodsResp = self.ymc.add_cart_goods(GoodsInfoData1, 5, LoginData)

                ''' step2：随机退购一个商品，并结算 '''
                allure.step("\n步骤5：退购一件商品")
                GetGoodsInfoList = [GoodsInfoData1]
                self.ymc.delete_cart_goods(GetGoodsInfoList, LoginData, AddGoodsResp)

                allure.step("步骤6：获取购物车商品信息")
                self.ymc.get_cart_goods_info([GoodsInfoData1])
                allure.step("步骤7：请求订单结算")
                self.ymc.request_order_settlement(LoginData)
            else:
                LOGGER.info(f"---商品 {self.weight_to_whitelist_goods["GoodsInputcode"]} 不存在")

            allure.step("[后置处理]：删除添加的重量放通白名单商品")
            self.yms.delete_weight_whitelist_goods()
        else:
            LOGGER.info(f"---添加商品 {self.weight_to_whitelist_goods['GoodsInputcode']} "
                        f"到重量放通白名单失败")


if __name__ == '__main__':
    unittest.main(verbosity=2)