# !/usr/bin/python
# -*- coding: utf-8 -*-
# @Author:: Arthur Wu
# @Description:: 游客转会员登录，加购普通商品，并结算
# @Date:: 2024/11/20
import unittest,allure,time
from configs.globalObj import LOGGER
from YiMao.businessFunc.ClientApiLib import YMClientApi
from YiMao.data.WuShangSceneTestData import *


DescName = "017-游客转会员登录，加购普通商品，并结算"
@allure.story(f'[场景测试] {DescName}验证')
class Test_C017(unittest.TestCase):
    f'''@Date:: 2024/11/15
    @Author:: Arthur Wu
    @Desc:: test_C003_NonVipAddNonDiscountedProductsForPurchase
    [购物车客户端] {DescName}
    1、武商测试环境，普通无优惠商品inputcode为：
       6924743915848
    '''
    def setUp(self) -> None:
        self.timestamp = int(time.time())
        self.ymc = YMClientApi()
        self.vip_phone_num = VIPPhoneNumber
        self.NormalGoodsInputcode01 = NormalGoodsInputcode01  # 乐事薯片

    def test_C017_NonToVipAddNonDiscountedProductsForPurchase(self):
        allure.dynamic.description(f"描述：{DescName}")
        allure.step("步骤1：session开始")
        self.ymc.session_start()
        allure.step("步骤2：匿名登录")
        Payload01 = {"action": 0, "isAnon": True}
        LoginData = self.ymc.login_app_v2(Payload01)

        allure.step("步骤3：切换会员登录")
        Payload02 = {"action": 1, "code": self.vip_phone_num, "isAnon": False}
        self.ymc.login_app_v2(Payload02)

        allure.step("步骤4：获取商品信息")
        GoodsInfoData = self.ymc.get_goods_info(InputCode=self.NormalGoodsInputcode01)
        if GoodsInfoData['msg'] != '加购商品不存在':
            allure.step("步骤5：添加无优惠商品")
            self.ymc.add_cart_goods(GoodsInfoData, 5, LoginData)
            allure.step("步骤6：获取购物车商品信息")
            self.ymc.get_cart_goods_info([GoodsInfoData])
            allure.step("步骤7：请求订单结算")
            self.ymc.request_order_settlement(LoginData)
        else:
            LOGGER.info(f"---商品 {self.NormalGoodsInputcode01} 不存在")


if __name__ == '__main__':
    unittest.main(verbosity=2)