# !/usr/bin/python
# -*- coding: utf-8 -*-
import unittest,allure,ddt,time,json,requests
from configs.globalObj import LOGGER
from configs.globalParams import *
from YiMao.config.ServiceApiInfo import *
from commons.FileHandler import ReadExcel
from commons.AssertLib import _assert_result
ExlFilePath = GlobalPath['YMDataPath'] + '/YMHT_ApiTestCase_0.0.1.xlsx'
ExcelContent = ReadExcel().get_data(FilePath=ExlFilePath, SheetName='01-超市管理')


@ddt.ddt
class Test_MarketManagementModule(unittest.TestCase):
    def setUp(self) -> None:
        self.timestamp = int(time.time())

    @allure.story('[管理平台] 超市管理模块')
    @ddt.data(*ExcelContent)
    def test_market_system_parameters(self, data):
        '''@Date:: 2024/5/20
        @Desc::
        管理后台 -> 超市管理模块接口
        '''
        ''' step01： '''
        allure.dynamic.title(data['CaseName'])
        allure.dynamic.description("描述：超市管理模块接口自动化测试")
        caseModule_c = data['BusinessModule']  # 用例编号
        caseNO_c = data['NO.']  # 用例编号
        caseName_c = data['CaseName']  # 用例名称
        requestType_c = str(data['RequestType'])  # 请求方式
        expStaCode_c = data['ExpStatusCode']  # 预期的状态码
        expRespJson_c = eval(data['RespJson'])  # 预期的返回体
        LOGGER.info(f">>> 开始执行->{caseModule_c}接口自动化测试 <<<\n")
        LOGGER.info(f"---用例编号为：{caseNO_c}")
        LOGGER.info(f"---用例名称为：{caseName_c}")
        LOGGER.info(f"---请求方式为：{requestType_c}")
        # LOGGER.info(f"---请求Header为：{HEADERS}")
        LOGGER.info(f"---预期接口返回码为：{expStaCode_c}")
        LOGGER.info(f"---预期返回体为：{expRespJson_c}\n")

        ''' step02- 请求接口 '''
        time.sleep(1)
        api_url = api_env[ProCfgData['ExecutionEnv']] + ManagementPlatformApi_zh[data['BusinessModule']] + "/64"  # 请求地址
        LOGGER.info(f"---请求接口为：{api_url}")
        payload_c = json.dumps(eval(data['Payload']), indent=4, ensure_ascii=False)  # 请求体为json格式
        LOGGER.info(f"---请求体为：{payload_c}\n")
        response = requests.request(method=requestType_c, url=api_url, headers=HEADERS, data=payload_c)
        rspJson = response.json()
        rspJsonFormat = json.dumps(response.json(), indent=4, ensure_ascii=False)
        LOGGER.info(f"---接口返回状态码为:: {response.status_code}")
        LOGGER.info(f"---接口返回体为:: {rspJsonFormat}\n")

        ''' step03- 断言处理 '''
        assert _assert_result(rspJson, expRespJson_c, LOGGER) == True, f"---断言失败！"
        LOGGER.info(f">>> {data['BusinessModule']}接口请求 & 断言执行结束 <<<\n\n")


if __name__ == '__main__':
    unittest.main(verbosity=2)

